Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
TiXmlElement Class Reference

`#include <tinyxml.h>`

Inheritance diagram for TiXmlElement:

## Public Member Functions
| TiXmlElement (const char *in_value)
| Construct an element. More...
| TiXmlElement (const TiXmlElement &)
TiXmlElement & | operator= (const TiXmlElement &base)
virtual | ~TiXmlElement ()
const char * | Attribute (const char *name) const
const char * | Attribute (const char *name, int *i) const
const char * | Attribute (const char *name, double *d) const
int | QueryIntAttribute (const char *name, int *_value) const
int | QueryUnsignedAttribute (const char *name, unsigned *_value) const
| QueryUnsignedAttribute examines the attribute - see QueryIntAttribute(). More...
int | QueryBoolAttribute (const char *name, bool *_value) const
int | QueryDoubleAttribute (const char *name, double *_value) const
| QueryDoubleAttribute examines the attribute - see QueryIntAttribute(). More...
int | QueryFloatAttribute (const char *name, float *_value) const
| QueryFloatAttribute examines the attribute - see QueryIntAttribute(). More...
void | SetAttribute (const char *name, const char *_value)
void | SetAttribute (const char *name, int value)
void | SetDoubleAttribute (const char *name, double value)
void | RemoveAttribute (const char *name)
const TiXmlAttribute * | FirstAttribute () const
| Access the first attribute in this element. More...
TiXmlAttribute * | FirstAttribute ()
const TiXmlAttribute * | LastAttribute () const
| Access the last attribute in this element. More...
TiXmlAttribute * | LastAttribute ()
const char * | GetText () const
virtual TiXmlNode * | Clone () const
| Creates a new Element and returns it - the returned element is a copy. More...
virtual void | Print (FileStream &stream, int depth) const
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type. More...
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null not of the requested type. More...
virtual bool | Accept (TiXmlVisitor *visitor) const
Public Member Functions inherited from TiXmlNode
virtual | ~TiXmlNode ()
const char * | Value () const
const TIXML_STRING & | ValueTStr () const
void | SetValue (const char *_value)
void | Clear ()
| Delete all the children of this node. Does not affect 'this'. More...
TiXmlNode * | Parent ()
| One step up the DOM. More...
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children. More...
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found. More...
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children. More...
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children. More...
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'. More...
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node. More...
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'. More...
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
| Returns true if this node has no children. More...
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type. More...
Public Member Functions inherited from TiXmlBase
| TiXmlBase ()
virtual | ~TiXmlBase ()
int | Row () const
int | Column () const
| See Row() More...
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...

## Protected Member Functions
void | CopyTo (TiXmlElement *target) const
void | ClearThis ()
const char * | ReadValue (const char *in, TiXmlParsingData *prevData, TiXmlEncoding encoding)
Protected Member Functions inherited from TiXmlNode
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)

## Additional Inherited Members
Public Types inherited from TiXmlNode
enum | NodeType { TINYXML_DOCUMENT, TINYXML_ELEMENT, TINYXML_COMMENT, TINYXML_UNKNOWN, TINYXML_TEXT, TINYXML_DECLARATION, TINYXML_TYPECOUNT }
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]
Static Protected Member Functions inherited from TiXmlBase
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | IsWhiteSpace (char c)
static bool | IsWhiteSpace (int c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Protected Attributes inherited from TiXmlNode
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
| Field containing a generic user pointer. More...
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

The element is a container class. It has a value, the element name, and can contain other elements, text, comments, and unknowns. Elements also contain an arbitrary number of attributes.

## Constructor & Destructor Documentation

TiXmlElement | ( | const char * | in_value | ) |

Construct an element.

TiXmlElement | ( | const TiXmlElement & | copy | ) |

~TiXmlElement | ( |  | ) |
| virtual

## Member Function Documentation

bool Accept | ( | TiXmlVisitor * | visitor | ) | const
| virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

const char * Attribute | ( | const char * | name | ) | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

const char * Attribute | ( | const char * | name,
|  | int * | i
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an integer, the integer value will be put in the return 'i', if 'i' is non-null.

const char * Attribute | ( | const char * | name,
|  | double * | d
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an double, the double value will be put in the return 'd', if 'd' is non-null.

void ClearThis | ( |  | ) |
| protected

TiXmlNode * Clone | ( |  | ) | const
| virtual

Creates a new Element and returns it - the returned element is a copy.

Implements TiXmlNode.

void CopyTo | ( | TiXmlElement * | target | ) | const
| protected

const TiXmlAttribute* FirstAttribute | ( |  | ) | const
| inline

Access the first attribute in this element.

TiXmlAttribute* FirstAttribute | ( |  | ) |
| inline

const char * GetText | ( |  | ) | const

Convenience function for easy access to the text inside an element. Although easy and concise, GetText() is limited compared to getting the TiXmlText child and accessing it directly.

If the first child of 'this' is a TiXmlText, the GetText() returns the character string of the Text node, else null is returned.

This is a convenient method for getting the text of simple contained text:

    <foo>This is text</foo>
    const char* str = fooElement->GetText();

'str' will be a pointer to "This is text".

Note that this function can be misleading. If the element foo was created from this XML:

    <foo><b>This is text</b></foo>

then the value of str would be null. The first child node isn't a text node, it is another element. From this XML:

    <foo>This is <b>text</b></foo>

GetText() will return "This is ".

WARNING: GetText() accesses a child node - don't become confused with the similarly named TiXmlHandle::Text() and TiXmlNode::ToText() which are safe type casts on the referenced node.

const TiXmlAttribute* LastAttribute | ( |  | ) | const
| inline

Access the last attribute in this element.

TiXmlAttribute* LastAttribute | ( |  | ) |
| inline

TiXmlElement & operator= | ( | const TiXmlElement & | base | ) |

const char * Parse | ( | const char * | p,
|  | TiXmlParsingData * | data,
|  | TiXmlEncoding | encoding
| ) |  |
| virtual

Implements TiXmlBase.

void Print | ( | FileStream & | stream,
|  | int | depth
| ) |  | const
| virtual

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implements TiXmlBase.

int QueryBoolAttribute | ( | const char * | name,
|  | bool * | _value
| ) |  | const

QueryBoolAttribute examines the attribute - see QueryIntAttribute(). Note that '1', 'true', or 'yes' are considered true, while '0', 'false' and 'no' are considered false.

int QueryDoubleAttribute | ( | const char * | name,
|  | double * | _value
| ) |  | const

QueryDoubleAttribute examines the attribute - see QueryIntAttribute().

int QueryFloatAttribute | ( | const char * | name,
|  | float * | _value
| ) |  | const
| inline

QueryFloatAttribute examines the attribute - see QueryIntAttribute().

int QueryIntAttribute | ( | const char * | name,
|  | int * | _value
| ) |  | const

QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking. If the attribute is an integer, it is stored in 'value' and the call returns TIXML_SUCCESS. If it is not an integer, it returns TIXML_WRONG_TYPE. If the attribute does not exist, then TIXML_NO_ATTRIBUTE is returned.

int QueryUnsignedAttribute | ( | const char * | name,
|  | unsigned * | _value
| ) |  | const

QueryUnsignedAttribute examines the attribute - see QueryIntAttribute().

const char * ReadValue | ( | const char * | in,
|  | TiXmlParsingData * | prevData,
|  | TiXmlEncoding | encoding
| ) |  |
| protected

void RemoveAttribute | ( | const char * | name | ) |

Deletes an attribute with the given name.

void SetAttribute | ( | const char * | name,
|  | const char * | _value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

void SetAttribute | ( | const char * | name,
|  | int | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

void SetDoubleAttribute | ( | const char * | name,
|  | double | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

virtual const TiXmlElement* ToElement | ( |  | ) | const
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

virtual TiXmlElement* ToElement | ( |  | ) |
| inline virtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

The documentation for this class was generated from the following files:

- persistence/tinyXML/tinyxml.h
- persistence/tinyXML/tinyxml.cpp
- persistence/tinyXML/tinyxmlparser.cpp